
import Overlayer from './overlay';

declare class CanvasOverlayer extends Overlayer {
    constructor(opts: CanvasLayerConfig);
    // declare internal props..
    canvas: HTMLCanvasElement;
    data: CanvasData;
    xfield: string;
    yfield: string;
    shadow: boolean;
    lineColor: string;
    blurWidth: string;
    keepTrack: boolean;
    redraw: (data?: CanvasData) => {};
    _transformLnglat: () => {};
    setTracks: (tracks: CanvasData) => {};
    getTracks: CanvasData;
}

export interface CanvasLayerConfig {
    canvas: HTMLCanvasElement;
    redraw: Function;
    data: CanvasData;
    labelOn?: boolean;
    xfield?: string;
    yfield?: string;
    shadow?: boolean;
    lineColor?: string;
    blurWidth?: number;
}

export type CanvasData = Array<Object> | [number, number][];
export default CanvasOverlayer;
